// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 This object represents a custom keyboard with reply options (see Introduction to bots for details and examples).

 SeeAlso Telegram Bot API Reference:
 [ReplyKeyboardMarkup](https://core.telegram.org/bots/api#replykeyboardmarkup)
 */
public final class ReplyKeyboardMarkup: Codable {

    /// Custom keys for coding/decoding `ReplyKeyboardMarkup` struct
    enum CodingKeys: String, CodingKey {
        case keyboard = "keyboard"
        case resizeKeyboard = "resize_keyboard"
        case oneTimeKeyboard = "one_time_keyboard"
        case selective = "selective"
    }

    /// Array of button rows, each represented by an Array of KeyboardButton objects
    public var keyboard: [[KeyboardButton]]

    /// Optional. Requests clients to resize the keyboard vertically for optimal fit (e.g., make the keyboard smaller if there are just two rows of buttons). Defaults to false, in which case the custom keyboard is always of the same height as the app's standard keyboard.
    public var resizeKeyboard: Bool?

    /// Optional. Requests clients to hide the keyboard as soon as it's been used. The keyboard will still be available, but clients will automatically display the usual letter-keyboard in the chat – the user can press a special button in the input field to see the custom keyboard again. Defaults to false.
    public var oneTimeKeyboard: Bool?

    /// Optional. Use this parameter if you want to show the keyboard to specific users only. Targets: 1) users that are @mentioned in the text of the Message object; 2) if the bot's message is a reply (has reply_to_message_id), sender of the original message.
    /// 
    /// Example: A user requests to change the bot‘s language, bot replies to the request with a keyboard to select the new language. Other users in the group don’t see the keyboard.
    public var selective: Bool?


    public init (keyboard: [[KeyboardButton]], resizeKeyboard: Bool? = nil, oneTimeKeyboard: Bool? = nil, selective: Bool? = nil) {
        self.keyboard = keyboard
        self.resizeKeyboard = resizeKeyboard
        self.oneTimeKeyboard = oneTimeKeyboard
        self.selective = selective
    }
}
